Option Strict On

Public Class CustomerWithParameterizedProperty

	Private custAccount As String
	Private custFirstName As String
	Private custLastName As String
	Private custDefaultQuantity As Integer = 12


    '        
	'   Property,    :
	Public Property DefaultQuantity(ByVal Multiplier As Integer) As Integer
		Get
            '   Get    .
            '    .  
            '      
            ' :
			Return custDefaultQuantity * Multiplier
		End Get
		Set(ByVal Value As Integer)
			custDefaultQuantity = Value
		End Set
	End Property

#Region "  Customer"

    Public Property AccountNumber() As String
        Get
            Return custAccount
        End Get
        Set(ByVal Value As String)
            custAccount = Value
        End Set
    End Property

    Public Property FirstName() As String
        Get
            Return custFirstName
        End Get
        Set(ByVal Value As String)
            custFirstName = Value
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return custLastName
        End Get
        Set(ByVal Value As String)
            custLastName = Value
        End Set
    End Property
#End Region
End Class
