Option Strict On

'   
'   ,   IAirTransport,
'    Fly
'        ,    
Interface IAirTransport
    Sub Fly()
End Interface

'  Plane
Public Class Plane
    '     Transport
    Inherits Transport
    '   IAirTransport
    Implements IAirTransport

    '     ,
    '        MustInherit
    Public Overrides ReadOnly Property Capacity() As Integer
        Get
            Return 120
        End Get
    End Property

    '     ,
    '        MustInherit
    Public Overrides ReadOnly Property DisplayName() As String
        Get
            Return ""
        End Get
    End Property

    '     ,
    '        MustInherit
    Public Overrides Function Load(ByVal passengersNumber As Integer) As Boolean
        Return passengersNumber <= Me.Capacity
    End Function

    '     
    '     IAirTransport
    Public Sub Fly() Implements IAirTransport.Fly
    End Sub

End Class

Public Class BigPlane
    '     Plane
    Inherits Plane

    Public Overrides ReadOnly Property DisplayName() As String
        Get
            Return " "
        End Get
    End Property

    Public Overrides ReadOnly Property Capacity() As Integer
        Get
            Return 250
        End Get
    End Property
End Class

Public Class SmallPlane
    '     Plane
    Inherits Plane

    '     Capacity  
    '   
    Public Shadows ReadOnly Property Capacity() As Integer
        Get
            Return 100
        End Get
    End Property

    Public Overrides ReadOnly Property DisplayName() As String
        Get
            Return " "
        End Get
    End Property
End Class


Public NotInheritable Class Helicopter
    '     Transport
    Inherits Transport
    '   IAirTransport
    Implements IAirTransport

    Private _capacity As Integer

    Sub New()
        _capacity = 8
    End Sub

    '     ,
    '        MustInherit
    Public Overrides ReadOnly Property Capacity() As Integer
        Get
            Return _capacity
        End Get
    End Property

    '     ,
    '        MustInherit
    Public Overrides ReadOnly Property DisplayName() As String
        Get
            Return ""
        End Get
    End Property

    '     ,
    '        MustInherit
    Public Overrides Function Load(ByVal passengersNumber As Integer) As Boolean
        Return passengersNumber <= Me.Capacity
    End Function

    '     
    '     IAirTransport
    Public Sub Fly() Implements IAirTransport.Fly
    End Sub
End Class

