Option Strict On

Imports System.Text
Imports System.Text.RegularExpressions


Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " ,     Windows "

    Public Sub New()
        MyBase.New()

        '     Windows.
        InitializeComponent()

        '     InitializeComponent()

    End Sub

    '   Dispose    .
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    '   Windows
    Private components As System.ComponentModel.IContainer

    ':       Windows.
    '      Windows.  
    '      .
    Friend WithEvents tbSourceText As System.Windows.Forms.TextBox
    Friend WithEvents lbTitle1 As System.Windows.Forms.Label
    Friend WithEvents lbTitle2 As System.Windows.Forms.Label
    Friend WithEvents tbProcessedText As System.Windows.Forms.TextBox
    Friend WithEvents btnSplit As System.Windows.Forms.Button
    Friend WithEvents btnUpperCase As System.Windows.Forms.Button
    Friend WithEvents btnMail As System.Windows.Forms.Button
    Friend WithEvents btnFindDate As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.tbSourceText = New System.Windows.Forms.TextBox
        Me.lbTitle1 = New System.Windows.Forms.Label
        Me.tbProcessedText = New System.Windows.Forms.TextBox
        Me.lbTitle2 = New System.Windows.Forms.Label
        Me.btnSplit = New System.Windows.Forms.Button
        Me.btnUpperCase = New System.Windows.Forms.Button
        Me.btnMail = New System.Windows.Forms.Button
        Me.btnFindDate = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'tbSourceText
        '
        Me.tbSourceText.Location = New System.Drawing.Point(176, 24)
        Me.tbSourceText.Multiline = True
        Me.tbSourceText.Name = "tbSourceText"
        Me.tbSourceText.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.tbSourceText.Size = New System.Drawing.Size(264, 112)
        Me.tbSourceText.TabIndex = 0
        Me.tbSourceText.Text = CType(configurationAppSettings.GetValue("tbSourceText.Text", GetType(System.String)), String)
        '
        'lbTitle1
        '
        Me.lbTitle1.Location = New System.Drawing.Point(176, 8)
        Me.lbTitle1.Name = "lbTitle1"
        Me.lbTitle1.Size = New System.Drawing.Size(100, 16)
        Me.lbTitle1.TabIndex = 1
        Me.lbTitle1.Text = " :"
        '
        'tbProcessedText
        '
        Me.tbProcessedText.Location = New System.Drawing.Point(176, 160)
        Me.tbProcessedText.Multiline = True
        Me.tbProcessedText.Name = "tbProcessedText"
        Me.tbProcessedText.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.tbProcessedText.Size = New System.Drawing.Size(264, 112)
        Me.tbProcessedText.TabIndex = 2
        Me.tbProcessedText.Text = ""
        '
        'lbTitle2
        '
        Me.lbTitle2.Location = New System.Drawing.Point(176, 144)
        Me.lbTitle2.Name = "lbTitle2"
        Me.lbTitle2.Size = New System.Drawing.Size(120, 16)
        Me.lbTitle2.TabIndex = 3
        Me.lbTitle2.Text = " :"
        '
        'btnSplit
        '
        Me.btnSplit.Location = New System.Drawing.Point(8, 56)
        Me.btnSplit.Name = "btnSplit"
        Me.btnSplit.Size = New System.Drawing.Size(160, 23)
        Me.btnSplit.TabIndex = 5
        Me.btnSplit.Text = ""
        '
        'btnUpperCase
        '
        Me.btnUpperCase.Location = New System.Drawing.Point(8, 24)
        Me.btnUpperCase.Name = "btnUpperCase"
        Me.btnUpperCase.Size = New System.Drawing.Size(160, 23)
        Me.btnUpperCase.TabIndex = 6
        Me.btnUpperCase.Text = " "
        '
        'btnMail
        '
        Me.btnMail.Location = New System.Drawing.Point(8, 88)
        Me.btnMail.Name = "btnMail"
        Me.btnMail.Size = New System.Drawing.Size(160, 23)
        Me.btnMail.TabIndex = 7
        Me.btnMail.Text = " e-mail "
        '
        'btnFindDate
        '
        Me.btnFindDate.Location = New System.Drawing.Point(8, 120)
        Me.btnFindDate.Name = "btnFindDate"
        Me.btnFindDate.Size = New System.Drawing.Size(160, 23)
        Me.btnFindDate.TabIndex = 8
        Me.btnFindDate.Text = " "
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(448, 278)
        Me.Controls.Add(Me.btnFindDate)
        Me.Controls.Add(Me.btnMail)
        Me.Controls.Add(Me.btnUpperCase)
        Me.Controls.Add(Me.btnSplit)
        Me.Controls.Add(Me.lbTitle2)
        Me.Controls.Add(Me.tbProcessedText)
        Me.Controls.Add(Me.lbTitle1)
        Me.Controls.Add(Me.tbSourceText)
        Me.Name = "frmMain"
        Me.Text = " "
        Me.ResumeLayout(False)

    End Sub

#End Region

    '     
    Private Sub btnSplit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSplit.Click

        '      .
        '      ";".
        '     sentences
        ' 
        Dim sentences() As String = tbSourceText.Text.Split(";"c)

        '       sentences.
        '     StringBuilder.
        '
        Dim resultString As New StringBuilder
        Dim i As Integer
        For i = 0 To sentences.Length - 1
            If sentences(i) <> String.Empty Then

                resultString.AppendFormat( _
                                        System.Environment.NewLine & " {0}:" _
                                        & "{1}", i + 1, sentences(i))
            End If
        Next

        tbProcessedText.Text = resultString.ToString()

    End Sub

    '      
    Private Sub btnUpperCase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpperCase.Click
        '        .
        '     ToUpper.
        tbProcessedText.Text = tbSourceText.Text.ToUpper()
    End Sub

    '      
    Private Sub btnMail_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMail.Click

        '    Regex.
        '      
        '   e-mail :
        ' ([a-zA-Z0-9_\.\-])+ -  ,    
        ' ,    "."  "-".
        ' \@ -  "@".
        ' (([a-zA-Z0-9\-])+\.)+ -  .
        ' ([a-zA-Z0-9]{2,4})+ -    .
        '
        Dim mailRegex As New Regex("([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+")
        Dim mailMatches As MatchCollection = mailRegex.Matches(tbSourceText.Text)

        '     e-mail .
        '     StringBuilder.
        '
        Dim resultString As New StringBuilder
        Dim i As Integer
        For i = 0 To mailMatches.Count - 1
            resultString.Append(mailMatches(i).ToString() + Environment.NewLine)
        Next

        tbProcessedText.Text = resultString.ToString()

    End Sub

    '          
    Private Sub btnFindDate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFindDate.Click
        On Error Resume Next
        '    Regex.
        '      
        '      dd.mm.yyyy  dd-mm-yyyy:
        ' (0[1-9]|[12][0-9]|3[01]) - 
        ' (0[1-9]|1[012]) - 
        ' (19|20)\d\d") -   
        '
        Dim dateReg As New Regex("(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d")
        Dim dateMatches As MatchCollection = dateReg.Matches(tbSourceText.Text)

        '   dates   .
        ' 
        Dim parsedDate As Date
        Dim dates As New ArrayList
        Dim i As Integer
        For i = 0 To dateMatches.Count - 1
            parsedDate = Convert.ToDateTime(dateMatches(i).ToString())
            dates.Add(parsedDate)
        Next

        '   
        '
        dates.Sort()

        '          
        Dim resultString As New StringBuilder
        For Each parsedDate In dates
            resultString.Append(parsedDate.ToLongDateString() + System.Environment.NewLine)
        Next

        tbProcessedText.Text = resultString.ToString()

    End Sub
End Class
