Option Strict On
Imports System.Runtime.Serialization
<Serializable()> Public Class StudentCustomSerialization
    Implements ISerializable

    Public Name As String
    Public Age As Integer

    Sub New(ByVal newName As String, ByVal newAge As Integer)
        Name = newName
        Age = newAge
    End Sub

    Sub New(ByVal info As SerializationInfo, _
            ByVal context As StreamingContext)
        Name = info.GetString("Name")
        Age = info.GetInt32("Age")
    End Sub

    Private Sub GetObjectData(ByVal info As SerializationInfo, _
                                ByVal context As StreamingContext) _
                                Implements ISerializable.GetObjectData
        info.AddValue("Name", Name)
        info.AddValue("Age", Age)
    End Sub

End Class
