Option Strict On
Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " ,     Windows "

    Public Sub New()
        MyBase.New()

        '     Windows.
        InitializeComponent()

        '     InitializeComponent()

    End Sub

    '   Dispose    .
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    '   Windows
    Private components As System.ComponentModel.IContainer

    ':       Windows.
    '      Windows.  
    '      .
    Friend WithEvents btnPolymorphism As System.Windows.Forms.Button
    Friend WithEvents btnShadow As System.Windows.Forms.Button
    Friend WithEvents btnInterface As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnPolymorphism = New System.Windows.Forms.Button
        Me.btnShadow = New System.Windows.Forms.Button
        Me.btnInterface = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'btnPolymorphism
        '
        Me.btnPolymorphism.Location = New System.Drawing.Point(16, 8)
        Me.btnPolymorphism.Name = "btnPolymorphism"
        Me.btnPolymorphism.Size = New System.Drawing.Size(192, 23)
        Me.btnPolymorphism.TabIndex = 0
        Me.btnPolymorphism.Text = ""
        '
        'btnShadow
        '
        Me.btnShadow.Location = New System.Drawing.Point(16, 40)
        Me.btnShadow.Name = "btnShadow"
        Me.btnShadow.Size = New System.Drawing.Size(192, 23)
        Me.btnShadow.TabIndex = 1
        Me.btnShadow.Text = ""
        '
        'btnInterface
        '
        Me.btnInterface.Location = New System.Drawing.Point(16, 72)
        Me.btnInterface.Name = "btnInterface"
        Me.btnInterface.Size = New System.Drawing.Size(192, 23)
        Me.btnInterface.TabIndex = 2
        Me.btnInterface.Text = ""
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(224, 110)
        Me.Controls.Add(Me.btnInterface)
        Me.Controls.Add(Me.btnShadow)
        Me.Controls.Add(Me.btnPolymorphism)
        Me.Name = "frmMain"
        Me.Text = " "
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnPolymorphism_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPolymorphism.Click

        '      
        ' Transport,        ,
        '   Transport (   ).
        '
        ' ,     
        '  .
        '
        ':     
        '  ..  (.   
        '  "")
        Dim transportArray(2) As Transport

        transportArray(0) = New Plane
        transportArray(1) = New Helicopter
        transportArray(2) = New BigPlane

        For Each trans As Transport In transportArray
            MsgBox(trans.DisplayName + ":  - " + _
            trans.Capacity.ToString(), , "")
        Next

    End Sub


    Private Sub btnShadow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShadow.Click

        ' smallPlaneAsSmallPlane  smallPlaneAsPlane
        '        SmallPlane
        Dim smallPlaneAsSmallPlane As New SmallPlane
        Dim smallPlaneAsPlane As Plane = smallPlaneAsSmallPlane

        '   smallPlaneAsSmallPlane.DisplayName  
        'smallPlaneAsPlane.DisplayName      
        ' ,    SmallPlane, ..   .
        '
        ' Capacity   SmallPlane   (Shadows)  Capacity
        ' Plane,    smallPlaneAsPlane.Capacity  
        ' ,    Plane,   
        'smallPlaneAsSmallPlane.Capacity - ,    SmallPlane.
        MsgBox(smallPlaneAsSmallPlane.DisplayName + ":  - " _
                + smallPlaneAsSmallPlane.Capacity.ToString(), , "")

        MsgBox(smallPlaneAsPlane.DisplayName + ":  - " _
               + smallPlaneAsPlane.Capacity.ToString(), , "")

    End Sub

    Private Sub btnInterface_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInterface.Click

        '  
        '  .
        Dim airTransportObject As IAirTransport
        airTransportObject = New SmallPlane
        airTransportObject.Fly()

    End Sub
End Class
