Option Strict On

Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization.Formatters.Soap
Imports System.IO

Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " ,     Windows "

    Public Sub New()
        MyBase.New()

        '     Windows.
        InitializeComponent()

        '     InitializeComponent()

    End Sub

    '   Dispose    .
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    '   Windows
    Private components As System.ComponentModel.IContainer

    ':       Windows.
    '      Windows.  
    '      .
    Friend WithEvents btnSerialize As System.Windows.Forms.Button
    Friend WithEvents btnDeserialize As System.Windows.Forms.Button
    Friend WithEvents btnSerializeXML As System.Windows.Forms.Button
    Friend WithEvents btnDeserializeXML As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnSerialize = New System.Windows.Forms.Button
        Me.btnDeserialize = New System.Windows.Forms.Button
        Me.btnSerializeXML = New System.Windows.Forms.Button
        Me.btnDeserializeXML = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'btnSerialize
        '
        Me.btnSerialize.Location = New System.Drawing.Point(16, 16)
        Me.btnSerialize.Name = "btnSerialize"
        Me.btnSerialize.Size = New System.Drawing.Size(176, 23)
        Me.btnSerialize.TabIndex = 0
        Me.btnSerialize.Text = ""
        '
        'btnDeserialize
        '
        Me.btnDeserialize.Location = New System.Drawing.Point(16, 48)
        Me.btnDeserialize.Name = "btnDeserialize"
        Me.btnDeserialize.Size = New System.Drawing.Size(176, 23)
        Me.btnDeserialize.TabIndex = 1
        Me.btnDeserialize.Text = ""
        '
        'btnSerializeXML
        '
        Me.btnSerializeXML.Location = New System.Drawing.Point(16, 80)
        Me.btnSerializeXML.Name = "btnSerializeXML"
        Me.btnSerializeXML.Size = New System.Drawing.Size(176, 23)
        Me.btnSerializeXML.TabIndex = 2
        Me.btnSerializeXML.Text = " (XML)"
        '
        'btnDeserializeXML
        '
        Me.btnDeserializeXML.Location = New System.Drawing.Point(16, 112)
        Me.btnDeserializeXML.Name = "btnDeserializeXML"
        Me.btnDeserializeXML.Size = New System.Drawing.Size(176, 23)
        Me.btnDeserializeXML.TabIndex = 3
        Me.btnDeserializeXML.Text = " (XML)"
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(208, 158)
        Me.Controls.Add(Me.btnDeserializeXML)
        Me.Controls.Add(Me.btnSerializeXML)
        Me.Controls.Add(Me.btnDeserialize)
        Me.Controls.Add(Me.btnSerialize)
        Me.Name = "frmMain"
        Me.Text = " "
        Me.ResumeLayout(False)

    End Sub

#End Region

    Protected students As New ArrayList

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '   students  StudentBasicSerialization 
        ' StudentCustomSerialization   .
        ' 
        students.Add(New StudentBasicSerialization("", 18))
        students.Add(New StudentCustomSerialization("", 18))
        students.Add(New StudentBasicSerialization("", 19))
        students.Add(New StudentCustomSerialization("", 18))
        students.Add(New StudentBasicSerialization("", 20))
    End Sub

    Private Sub btnSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        '    students    "students.bin".
        '     (stream),   ,  
        '    students,    BinaryFormatter .
        '
        Dim formatter As IFormatter = New BinaryFormatter
        Dim stream As Stream = New FileStream("students.bin", FileMode.Create, FileAccess.Write, FileShare.None)
        formatter.Serialize(stream, students)
        stream.Close()
    End Sub

    Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
        On Error Resume Next

        '      "students.bin".
        '
        students.Clear()
        Dim formatter As IFormatter = New BinaryFormatter
        Dim stream As Stream = New FileStream("students.bin", FileMode.Open, FileAccess.Read, FileShare.Read)

        students = CType(formatter.Deserialize(stream), ArrayList)
        stream.Close()

    End Sub

    Private Sub btnSerializeXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerializeXML.Click
        '    students  xml- "students.xml".
        '     (stream),   ,  
        '    ,    SoapFormatter .
        '  ,     
        '     "students.xml"
        '
        Dim formatter As IFormatter = New SoapFormatter
        Dim stream As Stream = New FileStream("students.xml", FileMode.Create, FileAccess.Write, FileShare.None)
        formatter.Serialize(stream, students)
        stream.Close()
    End Sub

    Private Sub btnDeserializeXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserializeXML.Click
        On Error Resume Next

        students.Clear()

        '    xml- "students.xml".
        '
        Dim formatter As IFormatter = New SoapFormatter
        Dim stream As Stream = New FileStream("students.xml", FileMode.Open, FileAccess.Read, FileShare.Read)
        students = CType(formatter.Deserialize(stream), ArrayList)
        stream.Close()
    End Sub
End Class
